#ifndef GOTOSTATEMENT_HPP
#define GOTOSTATEMENT_HPP

#include "Statement.hpp"
#include "LabelStatement.hpp"
#include "SourceLocation.hpp"


class GotoStatement: public Statement{
public:
	LabelStatement* getLabel();
	const LabelStatement* getLabel() const; 
	void setLabel(LabelStatement*);

	SourceLocation getGotoLocation() const;
	void setGotoLocation(SourceLocation);

	SourceLocation getLabelLocation() const;
	void setLabelLocation(SourceLocation);

private:
	SourceLocation _GotoLoc;
	LabelStatement* _Label;

};

#endif