#ifndef BLANGSTRING_HPP
#define BLANGSTRING_HPP

#include <string>
#include <list>
#include <regex>

namespace Blang{
	class string : public std::string
	{ 
	public:
		string();
		string(const std::string& str);
		string (const char* s);

		string ltrim();
		string rtrim();
		string trim();

        bool startsWith(string str, bool caseSensitive = true);
        bool startsWith(string str,string splitter, bool caseSensitive = true);
        bool startsWith(std::list<string> str, bool caseSensitive = true);
        bool startsWith(std::regex reg, bool caseSensitive = true);
	};
}

#endif
